import java.awt.*;
import javax.swing.*;

/**
 *  This main program simply creates a window on the screen that shows
 *  a "VideoPokerPanel" panel in the content area of the window.  The
 *  program exits when the user closes the window.  The window is
 *  non-resizable and is centered on the screen when it opens.
 */
public class NotVideoPokerFrame extends JFrame {
	
	public static void main(String[] args) {
		JFrame frame = new NotVideoPokerFrame();
		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		frame.setVisible(true);
	}
	
	public NotVideoPokerFrame() {
		super("Not Video Poker");
		JPanel panel = new VideoPokerPanel();   // Create a NotVideoPoker panel
		setContentPane(panel); // Set the window to display the panel as the windows "content".
		pack();   // Adjust size of window based on the panel's preferred size.
		setResizable(false);  // Don't let user change size of window.
		Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
		int w = (screenSize.width - getWidth()) / 2;  // for centering window on screen
		int h = (screenSize.height - getHeight()) / 2;
		setLocation(w,h);   // Set location of upper left corner of the window on the screen.
	}
	
}
